<template>
  <label :class="[!title ? 'simple' : '', 'c-checkbox']">
    <input
      type="checkbox"
      :value="value"
      :checked="modelValue"
      @change="$emit('update:modelValue', $event.target.checked)"
    />
    <span class="c-checkbox__mark"></span>
    {{ title ?? '' }}
    <slot></slot>
  </label>
</template>

<script setup>
import { defineProps } from 'vue';

defineProps({
  modelValue: null,
  title: String,
  value: [Number, String, Boolean]
});
</script>

<style lang="scss" scoped>
.c-checkbox {
  position: relative;
  display: flex;
  align-items: center;
  padding-left: 30px;
  input {
    position: absolute;
    opacity: 0;
    top: 0;
    left: 0;
  }

  &.simple {
    padding-left: 20px;
    height: 20px;
  }

  &__mark {
    width: 20px;
    height: 20px;
    position: absolute;
    top: 50%;
    left: 0;
    transform: translateY(-50%);
    &::after {
      content: '';
      position: absolute;
      opacity: 0;
      transition: ease-in-out 0.2s;
    }
  }

  input[type='checkbox'] + .c-checkbox__mark {
    @extend .c-checkbox__mark;
    border-radius: 3px;
    border: 1px solid #999999;

    &::after {
      width: 100%;
      height: 100%;
      top: 0;
      left: 0;
      background: royalblue;
    }
  }

  input[type='radio'] + .c-checkbox__mark {
    @extend .c-checkbox__mark;
    border-radius: 50%;
    border: 1px solid royalblue;
    &::after {
      border-radius: 50%;
      width: 80%;
      height: 80%;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      background: royalblue;
    }
  }

  input:checked + .c-checkbox__mark::after {
    opacity: 1;
  }
}
</style>
